;
; ----------------------------------------------------------
;
;	obNCgCo[^PWMvO
;
;	VR ɂAiKPx
;
;	Copyright(c) 2004 By Yutaka Kyotani
;
; ----------------------------------------------------------
;
	LIST		P=12F675
	INCLUDE		"P12F675.INC"
	INCLUDE		"YKMACRO.MAC"

	__CONFIG	_CP_OFF & _CPD_OFF & _BODEN_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT

	RADIX		dec

;
;	CLK= CRU 4MHz	 1߂1uS
;	PWMFreq= 91Hz		 11000tcy (44tcy * 250)

PWM_MINVALUE	EQU	.30		; PWMŏJEgl
PWM_MAXVALUE	EQU	.250		; PWMőJEgl
CSTART_COUNT	EQU	.180		; X^[g̍őPxێJEg=180(2b)

BRIGHT_VR	EQU	.0		; AIN0 = uCglXVR (ANALOG)
BKLT_ON_OFF	EQU	.3		; GPIO3= obNCgON/OFF (1:ON)
PWM_OUT		EQU	.5		; GPIO5= PWMo (1:ON)

GET_OSCCAL	EQU	03FFH		; IV[^[Lu[Vl𓾂

WORK1		EQU	020H		; [N擪

INTSAVE		EQU	WORK1		; 荞݃[`ł̃ReLXgۑp
WSAVE		EQU	INTSAVE+00H	; 荞 Wregۑp
SSAVE		EQU	INTSAVE+01H	; 荞 STATUSۑp
FSAVE		EQU	INTSAVE+02H	; 荞 FSRۑp

WORK2		EQU	WORK1+03H
ADVAL		EQU	WORK2+00H	; A/Dϊli[p
PWMVAL1		EQU	WORK2+01H	; PWM ONJEgl
PWMVAL2		EQU	WORK2+02H	; PWM OFFJEgl
CSTART		EQU	WORK2+03H	; X^[g̍őPxێJEg

	ORG	00H
	GOTO	START

	ORG	04H
	GOTO	INTERRUPT

;
; ----------------------------------------------------------
;
;	C[`
;
; ----------------------------------------------------------
;
START:
	BANK0				; BANK 0 I
	CLRF	GPIO			; GPIO NA
	MOVLW	B'00000111'		; Rp[^͑SDigital[h
	MOVWF	CMCON
	BANK1				; BANK 1 I
	CALL	GET_OSCCAL
	MOVWF	OSCCAL
	MOVLW	B'00001001'		; GPIO  --543210 -> --ooIooI
	MOVWF	TRISIO
	MOVLW	B'01100001'		; ADCS210 ANS3 ANS2 ANS1 ANS0
	MOVWF	ANSEL			; 110 /64 0:D  0:D  0:D  1:A
	MOVLW	B'10000000'		; GPPU  INTEDG TOCS  TOSE PSA PS210
	MOVWF	OPTION_REG		; 1:OFF 0:   0:INT 0: 0:T 000:1/2
	CLRF	INTCON			; |[g`FW荞݃tONA
	CLRF	IOC			; 荞݂ɂX[v̖ڊoߑΉ
	BANK0				; BANK 0 I

	MOVLW	B'00000011'		; A/DX^[g
	MOVWF	ADCON0
	MOVLW	PWM_MAXVALUE		; A/Ď(MAXl)ZbgĂ
	MOVWF	ADVAL
	MOVLW	CSTART_COUNT		; őPxێJEgZbg
	MOVWF	CSTART

LOOP_011:
	CALL	SLEEPCHK		; obNCgON/OFF(SLEEP) M̔
	CALL	PUT_PWM			; Nサ΂炭͍őPxo͂
	DJNZ	CSTART, LOOP_011

LOOP_012:
	CALL	SLEEPCHK		; obNCgON/OFF(SLEEP) M̔
	CALL	GET_ADVALUE		; őPxێԏIA/Dϊlo
	CALL	PUT_PWM

	GOTO	LOOP_012

;
;	A/Dϊꂽl𓾂
;
GET_ADVALUE:
	BTFSC	ADCON0, GO_DONE		; A/Dϊ͏IĂ邩H
	RETURN				; IĂȂ̂ł̂܂ܖ߂

	MOVF	ADRESH,W		; A/DϊʂǂݎčXV
	MOVWF	ADVAL			; 8Bit̂݃XgA
	MOVLW	B'00000011'		; A/DϊăX^[g
	MOVWF	ADCON0

	RETURN

;
;	AiOݒlPWMo͂
;
PUT_PWM:
	MOVLW	.0 - PWM_MINVALUE	; ŏl̃`FbN
	ADDWF	ADVAL,W			; A/Dϊl͍ŏl𒴂Ă邩
	MOVF	ADVAL,W
	SKIPC				; C: >= PWM_MINVALUE
	MOVLW	PWM_MINVALUE		; ŏlȂŏlɊۂ߂
	MOVWF	PWMVAL1			; PWM ONJEglƂĊi[

	MOVLW	.0 - PWM_MAXVALUE	; ől̃`FbN
	ADDWF	PWMVAL1,W		; A/Dϊl͍ől𒴂Ă邩
	MOVLW	PWM_MAXVALUE
	SKIPNC				; NC: < PWM_MAXVALUE
	MOVWF	PWMVAL1			; őlȏȂőlɊۂ߂

	MOVF	PWMVAL1,W		; PWM OFFJEgľvZ
	SUBLW	PWM_MAXVALUE + .1	; PWM_MAXVALUE + 1 - ONJEg
	MOVWF	PWMVAL2			; -1̂ +1Ă

	BSF	GPIO, PWM_OUT		; GP5= PWM OUT ON
PUTPWM_010:
	CALL	PWM_DELAY
	DJNZ	PWMVAL1, PUTPWM_010	; PWM ONJEgl܂Ŏԑ҂

	DJNZ	PWMVAL2, PUTPWM_020	; PWM OFFJEg 0
	RETURN				; 0ȂOFFȂ ON̂܂ܖ߂

PUTPWM_020:
	CLRF	GPIO			; PWM OUT OFF
PUTPWM_021:
	CALL	PWM_DELAY
	DJNZ	PWMVAL2, PUTPWM_021	; PWM OFFJEgl܂Ŏԑ҂
	BSF	GPIO, PWM_OUT		; GP5= PWM OUT ON

	RETURN

;
;	PWMp 41tcyDELAY
;
PWM_DELAY:
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1

	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1

	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1

	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	NOP
	RETURN

;
;	obNCgON/OFF(SLEEP) M̔
;
SLEEPCHK:
	BTFSC	GPIO, BKLT_ON_OFF
	RETURN				; |[gONȂ炻̂܂ܖ߂

	CLRF	GPIO			; |[gOFFȂ PWMo͂OFF
	CALL	PWM_DELAY

	CLRF	GPIO			; ēxGPIONA
	BANK1				; BANK 1 I
	CLRF	INTCON			; |[g`FW荞݃tONA
	CLRF	IOC
	BANK0				; BANK 0 I
	BTFSC	GPIO, BKLT_ON_OFF
	GOTO	START			; Ń|[gONȂR[hX^[g

	BANK1				; BANK 1 I
	BSF	INTCON, GPIE		; |[g`FW荞݋
	BSF	IOC, BKLT_ON_OFF
	BANK0				; BANK 0 IE
	SLEEP				; GIEONɂĂȂ̂Ŏ̖߂s
	GOTO	START			; SLEEP̋N̓R[hX^[g
;
;	荞݃[`
;
;	Ӂ@݂̓_~[ł
;
INTERRUPT:
	MOVWF	WSAVE			; Wregۑ
	SWAPF	STATUS,W		; STATUSۑ
	MOVWF	SSAVE
	MOVF	FSR,W			; FSRۑ
	MOVWF	FSAVE

	BANK0				; BANK 0 I
					; Ɋ荞ݏւ̕Lq
	MOVF	FSAVE,W
	MOVWF	FSR			; FSRA
	SWAPF	SSAVE,W
	MOVWF	STATUS			; STATUSA
	SWAPF	WSAVE,F			; WregA
	SWAPF	WSAVE,W			; Zflagی̂SWAPFgp
	RETFIE

	END
